# VTools - 3D-Turtle
# Opensource
# Autoren R. Oldemburg, M. Rabel, J. Schuster, Uni Frankfurt 
# Kontakt oldenbur@math.uni-frankfurt.de

# Mini 3D-DGS-Geometrieprogramm 
# An den Basispunkten kann mit der Maus gezogen werden

from VTools import *

scene.autoscale=0

objs=[]	# Objekt-Liste

def berechneAlle(): 
    for obj in objs: 
        if not(obj.calc==None): obj.calc()

ziehPunkt=None # Das ist der Punkt, an dem gezogen wird

def dragEnde(*restlargumente):
    global ziehPunkt
    ziehPunkt=None
setReleaseEvent(dragEnde)

def setzeziehePunkt(p): # Liefert eine Funktion, die den zu ziehenden Punkt setzt
    def setze(*restlicheArgumente):
        global ziehPunkt
        ziehPunkt=p
    return setze

def ziehe(scene):
        if not(ziehPunkt==None): ziehPunkt.pos=scene.mouse.pos
        berechneAlle()
setLoopProc(ziehe)

def makePoint(pos): # P ist Position als 3-Vector
    p=sphere(pos=pos,radius=0.2,color=color.red)
    p.calc=None
    objs.append(p)
    setObjectsPressEvent(p,setzeziehePunkt(p))
    return p

def makeMidPoint(A,B): 
    p=sphere(pos=(A.pos+B.pos)/2.0,radius=0.3,color=color.red)
    def berechne(): p.pos=(A.pos+B.pos)/2.0
    p.calc=berechne
    objs.append(p)
    return p

def makeSegment(A,B): # Strecke zwischen A und B
    s=cylinder(pos=A.pos,axis=B.pos-A.pos,color=color.blue,radius=0.1)
    def berechne():
        s.pos=A.pos
        s.axis=B.pos-A.pos
    s.calc=berechne
    objs.append(s)
    return s

def makeSphere(M,P):
    s=sphere(pos=M.pos,radius=1)
    def berechne():
        s.pos=M.pos
        s.radius=mag(M.pos-P.pos)
    berechne()
    s.calc=berechne
    objs.append(s)
    return s

def makePlane(A,B,C):
    e=box(color=color.yellow)
    e.opacity=0.4
    def berechne():
        # A als Aufpunkt, u,v, Richtungsvektoren, n als Normalenvektor
        u=B.pos-A.pos
        v=C.pos-A.pos
        n=cross(u,v)
        n=n/mag(n) # normiert
        e.pos=A.pos
        e.axis=n*0.02
        gr=max(2,2*mag(u),2*mag(v))
        e.width=gr
        e.height=gr
    berechne()
    e.calc=berechne
    objs.append(e)
    return e
    
# - die Konstruktion -----
[A,B,C]=[makePoint((-3,1,1)),makePoint((3,1,1)),makePoint((0,5,1))]
a=makeSegment(B,C)
b=makeSegment(A,C)
c=makeSegment(A,B)
Ma=makeMidPoint(A,B)
S=makeSphere(A,Ma)
E=makePlane(A,B,C)
S.opacity=0.4

Tkosys()
Vrate=50
Vmainloop()

